---  dp:  eine Interpretation
---  dpalledpalle alle Interpretationen
---  dpfcnf: eine Interpretation der Klauselmenge,
---           aber: Tautologien knnen als nur erfllbar erkannt werden
---                 fuehrt keine Tautologien ein 
---                 Widersprche bleiben erkennbar
---  dpallefcnf :  alle Interpretationen
---  cnffast   ist die cnf dazu   


module DavisPutnamschnell(module Simp,module DavisPutnamschnell) where
import Data.List
import Simp
import Debug.Trace

type Literal =  Int
----  type Literal =  Integer
type Klausel = [Literal]
type KlauselMenge = [Klausel]

getCNF inp = let (subs,e) = numPropSubs . parseProp $ inp
                 inpcnf =  cnf e
                 res =  dpcnf $ inpcnf 
             in   res 
             
         

dp  inp =   let (subs,e) = numPropSubs . parseProp $ inp
                inpcnf =  cnf e
                res = davisPutnam . dpcnf $ inpcnf 
                ares = backSubs res subs
             in 
                 if   inpcnf == (Pand [])     --  alles ist wegsimplifiziert  
                  then  "Formel ist Tautologie"
                 else
                if null ares  
                then "Formel ist Widerspruch"
                else "Modell: " ++ (foldr1 (\x y-> x ++ (", " ++ y)) ares)

dpalle  inp =   let (subs,e) = numPropSubs . parseProp $ inp
                    ress = davisPutnamAlle . dpcnf . cnf $ e
                    ares = map (\x-> backSubs x subs)   ress
             in  ares 

dpfcnf inp = let (subs,e) = numPropSubs . fastcnfInt . parseProp $ inp
                 inpcnf =  cnf e
                 res = davisPutnam . dpcnf $ inpcnf 
                 ares = backSubs res subs
                 
                 (subsTAUT,eTAUT) = numPropSubs . fastcnfInt . addPnot . parseProp $ inp
                 inpcnfTAUT =  cnf eTAUT
                 resTAUT = davisPutnam . dpcnf $ inpcnfTAUT 
                 aresTAUT = backSubs resTAUT subsTAUT
             in 
                 if   inpcnf == (Pand [])     --  alles ist wegsimplifiziert (kommt nicht vor)  
                  then  "Formel ist Tautologie"
                 else
                if null ares  
                then "Formel ist Widerspruch"
                else 
                if null aresTAUT 
                then "Formel ist Tautologie"
                else "Modell: " ++ (foldr1 (\x y-> x ++ (", " ++ y)) ares)    

dpallefcnf  inp =   let (subs,e) = numPropSubs . fastcnfInt . parseProp $ inp
                        ress = davisPutnamAlle . dpcnf . cnf $ e
                        ares = map (\x-> backSubs x subs)   ress
                 in  ares 
                                         
dpalt = davisPutnam . dpcnf . cnf . numProp . parseProp

davisPutnam klauselMenge =  davisPutnamSat (map sort klauselMenge) [] 
  
davisPutnamSat :: KlauselMenge -> [Literal] -> [Literal]
davisPutnamSat [] loesung = loesung
davisPutnamSat klauselMenge loesung
    | [] `elem` klauselMenge = []
    | otherwise 
        = case findUnits klauselMenge True of 
            Just [u] -> davisPutnamSat (resolveUnit u klauselMenge) (u:loesung)
            Just us -> davisPutnamSat (resolveUnits us (dualrevunits us) klauselMenge) (us ++ loesung)
            Nothing -> 
        --        case findPureLiteral klauselMenge of 
        --          Just unit -> 
        --              davisPutnamSat (resolveUnit unit klauselMenge)
         --                                (unit:loesung)
         --         Nothing -> 
                          let minUnit = findBestLiteral klauselMenge
                            in
                            case davisPutnamSat 
                                  (resolveUnit minUnit klauselMenge)
                                  (minUnit:loesung) of
                              [] -> davisPutnamSat 
                                     (resolveUnit (- minUnit) klauselMenge)
                                     ((- minUnit):loesung)
                              xs -> xs

davisPutnamAlle klauselMenge =  davisPutnamSatAlle (map sort klauselMenge) [[]] 

davisPutnamSatAlle :: KlauselMenge -> [[Literal]] -> [[Literal]]

davisPutnamSatAlle [] loesungen = loesungen
davisPutnamSatAlle klauselMenge loesungen
    | [] `elem` klauselMenge = []
    | otherwise = 
    case findUnits klauselMenge False of 
            Just [u] -> davisPutnamSatAlle (resolveUnit u klauselMenge) 
                                           (map (u:) loesungen)
            Just us -> davisPutnamSatAlle (resolveUnits us (dualrevunits us) klauselMenge) 
                                         (map (us ++) loesungen)
        --      Nothing -> case findPureLiteral klauselMenge of 
		--       Just unit -> 
		--	   davisPutnamSatAlle (resolveUnit unit klauselMenge)
		--				  (map (unit:) loesungen)
            Nothing -> (davisPutnamSatAlle 
				   (resolveUnit minUnit klauselMenge)
				   (map (minUnit:) loesungen))
				  ++
				  (davisPutnamSatAlle 
				   (resolveUnit (- minUnit) klauselMenge)
				   (map ((- minUnit):) loesungen))
    where minUnit = findBestLiteral klauselMenge

----   --99999999  in Ergebnis:   widerspruechlich
----      88888888  in Ergebnis:   ab da beginnt die Suche

davisPutnamSatLazy km =  davisPutnamSatLazyr (map sort km) []

davisPutnamSatLazyr :: KlauselMenge -> [Literal] -> [Literal]
davisPutnamSatLazyr [] loesung = loesung
davisPutnamSatLazyr klauselMenge loesung
    | [] `elem` klauselMenge = [-99999999]
    | otherwise 
        = case findUnits klauselMenge True of 
            Just [u] -> u :  (davisPutnamSatLazyr (resolveUnit u klauselMenge) (loesung))
            Just us -> us ++  (davisPutnamSatLazyr (resolveUnits us (dualrevunits us) klauselMenge) (loesung))
            Nothing -> 
     --           case findPureLiteral klauselMenge of 
     --             Just unit -> 
     --                 unit: (davisPutnamSatLazyr (resolveUnit unit klauselMenge) loesung) 
     --            Nothing -> 
                          let minUnit = findBestLiteral klauselMenge
                            in
                            88888888 :
                            (case davisPutnamSat 
                                   (resolveUnit (-minUnit) klauselMenge)
                                   ((-minUnit):loesung) of
                               [] -> davisPutnamSatLazyr 
                                      (resolveUnit  minUnit  klauselMenge)
                                      (minUnit :loesung)
                               xs -> xs)



--  dualrevunits us = reverse (map (\x -> -x) us)

dualrevunits us = let revus =  reverse (map (\x -> -x) us)
                  in if (not ((sorted us) && sorted revus))
                     then error ("sortfehler" ++ (show (us,revus)))
                     else revus

sorted [] = True
sorted [x] = True
sorted (x:(y:rest)) = x < y && sorted (y:rest)

findMinUnit :: Int -> Literal -> KlauselMenge -> Literal
findMinUnit _ minUnit [] = minUnit
findMinUnit min minUnit (k@(l:ls):ks)
    | min > length k = findMinUnit (length k) l ks
    | otherwise = findMinUnit min minUnit ks

findMinLength        :: Int -> KlauselMenge -> Int
findMinLength min [] = min
findMinLength min (k:ks)
  | min > length k   = findMinLength (length k) ks
  | otherwise        = findMinLength min ks

findBestLiteral :: KlauselMenge -> Literal
findBestLiteral ([l1,_]:ks) = l1
findBestLiteral klauselMenge@(k:ks)
    = let minLen=findMinLength (length k) klauselMenge
          aList=findBestLiteralAl minLen [] klauselMenge
          in findBestLiteralAlm aList

findBestLiteralAlm :: [(Literal, Int)] -> Literal
findBestLiteralAlm ((l,n):aList)
    = findBestLiteralAlmR n l aList

findBestLiteralAlmR        :: Int -> Literal -> [(Literal, Int)] -> Literal
findBestLiteralAlmR _ l [] = l
findBestLiteralAlmR max litMax ((l,n):aList)
    | n > max              = findBestLiteralAlmR n l aList
    | otherwise            = findBestLiteralAlmR max litMax aList

findBestLiteralAl :: Int -> [(Literal, Int)] -> KlauselMenge -> [(Literal, Int)]
findBestLiteralAl _ as [] = as
findBestLiteralAl minLen aList (k:ks)
    | minLen == length k 
        = findBestLiteralAl minLen (findBestLiteralAlR k aList) ks
    | otherwise = findBestLiteralAl minLen aList ks

findBestLiteralAlR :: Klausel -> [(Literal, Int)] -> [(Literal, Int)]
findBestLiteralAlR [] as = as
findBestLiteralAlR (l:ls) aList
    = let a = abs l
          in
          case lookup a aList of
          Nothing -> findBestLiteralAlR ls ((a, 1):aList)
          Just n -> findBestLiteralAlR ls ((a, n+1):(delete (a,n) aList))
          
      
resolveUnit         :: Literal -> KlauselMenge -> KlauselMenge
resolveUnit _ []    = []
resolveUnit unit (k:ks) 
    | unit `elem` k = resolveUnit unit ks
    | otherwise     = (mengenRemSortiert k (- unit)) :(resolveUnit unit ks)
 --   | otherwise     = [l|l <- k, (- unit) /= l]:(resolveUnit unit ks)
    
resolveUnits         :: [Literal] -> [Literal] -> KlauselMenge -> KlauselMenge
resolveUnits _ _ []    = []
resolveUnits units dualunits (k:ks) 
    | schnittNichtLeer units dualunits = [[]]
    | otherwise     = resolveUnitsR units dualunits (k:ks) 
    
resolveUnitsR         :: [Literal] -> [Literal] -> KlauselMenge -> KlauselMenge
resolveUnitsR _ _ []    = []
resolveUnitsR units dualunits (k:ks) 
    | schnittNichtLeer units k = resolveUnitsR units dualunits ks
    | otherwise     = (mengenMinusSortiert k dualunits) :(resolveUnitsR units dualunits ks)

--   die ist mehrfach langsamer als die vordefiniert elem
sortElem x [] = False
sortElem x (y:ys) = if x > y then sortElem x ys
                    else if x == y then True else False

mengenRemSortiert [] _ = []
mengenRemSortiert (l:ls) u   = 
    if u > l then l : mengenRemSortiert ls u 
    else if u == l  then ls else l : ls 
         
mengenMinusSortiert [] _ = []
mengenMinusSortiert ls [] = ls
mengenMinusSortiert (l:ls) (u:us)   = 
    if l == u then mengenMinusSortiert  ls us
    else if l < u then l : mengenMinusSortiert ls (u:us) 
         else mengenMinusSortiert (l:ls) us 
         

schnittNichtLeer [] _ = False
schnittNichtLeer _ [] = False
schnittNichtLeer (x:xs) (y:ys) = 
       if x == y then True
       else if x < y then   schnittNichtLeer xs (y:ys) 
            else   schnittNichtLeer (x:xs) ys 

findUnit         :: KlauselMenge -> Maybe Literal
findUnit []      = Nothing
findUnit ([x]:_) = Just x
findUnit (_:xs)  = findUnit xs

-- flag gibt an ob auch isolierte Literale gesucht werden sollen
findUnits      :: KlauselMenge -> Bool -> Maybe [Literal]
findUnits km flag = 
   let einslisten =  findeinslistenSchnell km
       purelits = if flag then  findPureLiterals km else []
       gef =  sort (nub (einslisten ++ purelits))
    in if istLeer einslisten 
        then Nothing
        else Just gef

findeinslisten [] = []
findeinslisten ([x]:xs) = x: findeinslisten xs
findeinslisten (_:xs) =  findeinslisten xs

findeinslistenSchnell km = findeinslistenSchnellR km km  []
findeinslistenSchnellR km ([x]:xs) gef = findeinslistenSchnellR  km xs  (sortInsert (-x) gef)
findeinslistenSchnellR km (k:xs) gef =  
       let krest = mengenMinusSortiert k gef
        in if lengthEq1 krest then findeinslistenSchnellR km xs  (sortInsert (- (head krest)) gef)
           else findeinslistenSchnellR km xs  gef
findeinslistenSchnellR km [] gef =  
    if lengthGt2 gef && nichtLeer km 
    then findeinslistenSchnellR [] km  gef
    else    reverse (map (\x -> -x) gef)

istLeer [] = True
istLeer _ = False

nichtLeer [] = False
nichtLeer _ = True

lengthEq1 [] = False
lengthEq1 (x:y:_) = False
lengthEq1 _ = True

lengthGt2 (x:y:z:_) = True
lengthGt2 _ = False

sortInsert x [] = [x]
sortInsert x (y:ys) = if x < y then x:y:ys 
                      else if x == y then y:ys else   y: (sortInsert x ys)   


translateSolution :: [Literal] -> [Literal]
translateSolution solution
    = translateSolutionR 1 (absMax solution) solution

translateSolutionR :: Literal -> Literal -> [Literal] -> [Literal]
translateSolutionR n max solution
    | n `elem` solution = 1:(translateSolutionR (n+1) max solution)
    | (-n) `elem` solution = -1:(translateSolutionR (n+1) max solution)
    | max >= n = 0:(translateSolutionR (n+1) max solution)
    | otherwise = []

absMax :: [Literal] -> Literal
absMax (s:ss) = absMaxR (abs s) ss

absMaxR :: Literal -> [Literal] -> Literal
absMaxR max [] = max
absMaxR max (s:ss) 
    | max > (abs s) = absMaxR max ss
    | otherwise = absMaxR (abs s) ss
    
findPureLiterals :: KlauselMenge ->   [Literal]
findPureLiterals km = 
   let kmsort = sort (nub (concat km))
    in  mengenMinusSortiert kmsort (dualrevunits kmsort)
   
    
findPureLiteral :: KlauselMenge -> Maybe Literal
findPureLiteral (k:ks)
    = findPureLitR [] k ks

findPureLitR :: [Literal] -> Klausel -> KlauselMenge -> Maybe Literal
findPureLitR _ [] [] = Nothing
findPureLitR literals [] (k:ks)
    = findPureLitR literals k ks
findPureLitR literals (k:ks) klauselMenge
    | abs k `elem` literals = findPureLitR literals ks klauselMenge
    | otherwise 
        = let nlit = -k
              in
              if any (elem nlit) klauselMenge
                 then findPureLitR ((abs nlit):literals) ks klauselMenge
                 else Just k

subsumesAlmost :: Klausel -> Klausel -> Bool
subsumesAlmost [] _ = True
subsumesAlmost (k:kl) kl2
    | k `elem` kl2 = subsumesAlmost kl kl2
    | -k `elem` kl2 = subsetp kl kl2
    | otherwise = False

subsetp :: Eq a => [a] -> [a] -> Bool
subsetp as bs = all (flip elem bs) as


-- dpFool1 :: Int -> [[Literal]]
-- dpFool1 1 = [[1, -1]]
-- dpFool1 n = 
--     let nxfool = dpFool1 (n-1)
 --        in (davorConsen n nxfool) ++ (davorConsen (-n) nxfool)

-- davorConsen         :: a -> [[a]] -> [[a]]
-- davorConsen el list = map (el:) list

---------------
--  elternResolution:   zb [a,b,c]  [-a,b]  ergibt :    [b,c]  [-a,b] 
elternRes k e  = 
   let k1 = mengenMinusSortiert k e        --  jetzt darf nur noch eins uebrigsein
       k1h = head k1
       ok = lengthEq1 k1  && ((- k1h) `elem` e)
     in if ok  then   (mengenRemSortiert e (- k1h))
        else e

elternResKM k km = map (elternRes k) km
    
