

-- Aussagenlogik-Umwandlung.

module Simp(module Prop, module SimpCnf, module Simp) where
--
import Data.List
import Prop
import SimpCnf
--------------------------

{-

already imported from "Prop"
data Pexpr = Ptrue | Pfalse | Pand [Pexpr] | Por [Pexpr] | Pimpl  Pexpr Pexpr 
     |  Pequiv  Pexpr Pexpr | Pnot Pexpr | Pvar Int

data Pexpr = Ptrue | Pfalse | Pand [Pexpr] | Por [Pexpr] | Pimpl  Pexpr Pexpr 
     |  Pequiv  Pexpr Pexpr | Pnot Pexpr | Pvar String
    deriving (Eq,Show)
-}



--  Vermutlich geht es mit Quantoren nicht 
 

pelimequiv Ptrue = Ptrue
pelimequiv Pfalse = Pfalse
pelimequiv (Pvar x) = (Pvar x) 
pelimequiv (Pand es) = Pand (map pelimequiv es) 
pelimequiv (Por es) =  Por (map pelimequiv es) 
pelimequiv (Pimpl e f) = Pimpl (pelimequiv e) (pelimequiv  f)  
pelimequiv (Pequiv e f) = 
    let en =  (pelimequiv e)
        fn =  (pelimequiv f)
     in Pand [Pimpl en fn, Pimpl fn en]
pelimequiv (Pnot e) =  Pnot (pelimequiv e) 

pelimimpl Ptrue = Ptrue 
pelimimpl Pfalse = Pfalse
pelimimpl (Pvar x) = (Pvar x) 
pelimimpl (Pand es) = Pand (map pelimimpl es)  
pelimimpl (Por es) = Por (map pelimimpl es)  
pelimimpl (Pimpl e f) = Por [(Pnot (pelimimpl e)), (pelimimpl  f)]  
pelimimpl (Pnot e) =  (Pnot (pelimimpl e)) 

pelimnot Ptrue = Ptrue 
pelimnot Pfalse = Pfalse
pelimnot (Pvar x) = (Pvar x) 
pelimnot (Pnot (Pvar x)) = (Pnot (Pvar x))
pelimnot (Pnot Pfalse) = Ptrue
pelimnot (Pnot Ptrue) = Pfalse
pelimnot (Pnot (Ptrue)) = Pfalse
pelimnot (Pand es) = Pand (map pelimnot es)  
pelimnot (Por es)  = Por (map pelimnot es)  
pelimnot (Pnot (Pnot e)) = pelimnot e 
pelimnot (Pnot (Pand es)) = Por (map pelimnot (map Pnot es))
pelimnot (Pnot (Por es))  = Pand (map pelimnot (map Pnot es))


---   0,1,  aus Formeln eliminieren
pelimTF :: (Eq name, Show name) => Pexpr name -> Pexpr name
pelimTF  xs =    
     let res = pelimTFR . pelimTFR  $ xs 
     in if res == Ptrue then Pand [Ptrue]
        else if res == Pfalse then Pand [Pfalse]
        else res

pelimTFR Ptrue = Ptrue 
pelimTFR Pfalse = Pfalse
pelimTFR (Pvar x) = (Pvar x) 
pelimTFR (Pnot x) = Pnot (pelimTFR x)
pelimTFR (Pand es) = 
      let esn = map pelimTFR es
          esn2 = deleteAll Ptrue esn
       in if (Pfalse `elem` esn2) 
          then Pfalse 
          else if   (esn2 == [])
               then Ptrue else Pand esn2
pelimTFR (Por es) = 
      let esn = map pelimTFR es
          esn2 = deleteAll Pfalse esn
       in if (Ptrue `elem` esn2) 
          then Ptrue 
          else if  (esn2 == [])
               then Pfalse 
               else Por esn2
                       
deleteAll x [] = []
deleteAll x (y:ys) = if x == y then deleteAll x ys else y : (deleteAll x ys) 
               

portop (Por _) = True
portop _ = False
pandtop (Pand _) = True
pandtop _ = False

--pelimflatr (Por es) = if (any  portop es) 
--       then Por (concat (map porsublst es)) 
--       else (Por (map pelimflat2 es))
--pelimflatr (Pand es) = if (any  pandtop es) 
--       then Pand (concat (map pandsublst es)) 
--       else (Pand (map pelimflat2 es))
--pelimflatr x = x 
--pelimflatr2 (Por es) = if (any  portop es) 
--       then Por (concat (map porsublst es)) 
--       else (Por (map pelimflat3 es))
--pelimflatr2 (Pand es) = if (any  pandtop es) 
--       then Pand (concat (map pandsublst es)) 
--       else (Pand (map pelimflat3 es))
--pelimflatr2 x = x        
pelimflatr (Por es) = if (any  portop es) 
       then Por (concat (map porsublst es)) 
       else (Por (map pelimflatr es))
pelimflatr (Pand es) = if (any  pandtop es) 
       then Pand (concat (map pandsublst es)) 
       else (Pand (map pelimflatr es))
pelimflatr x = x
 
porsublst (Por e) = e
porsublst  e = [e] 

pandsublst (Pand e) = e
pandsublst  e = [e] 

pelimflat x =
   let xn = pelimflatr x
   in if x /= xn then pelimflat xn
      else xn

--pelimflat x =
--   let xn = pelimflatr x
--   in if x /= xn then pelimflat2 xn
--      else xn

--pelimflat2 x =
--   let xn = pelimflatr2 x
--   in if x /= xn then error ((show x) ++ (show xn))  
--          --- pelimflat3 xn
--      else xn
      
--pelimflat3 x = error ("flat3" ++ (show  x))
--   let xn = pelimflatr x
--   in  xn
----
---   distribut   fehlt
---
pistliteral  Ptrue = True 
pistliteral Pfalse = True
pistliteral (Pvar x) = True
pistliteral (Pnot (Pvar x)) = True
pistliteral _ = False

istklausel (Por xs) = all (pistliteral) xs 
istklausel _   = False
istklauselemenge (Pand xs) = 
       all (\xss -> istklausel xss) xs
istklauselemenge _  = False 

----pcnf  ein  = error ("pcnf " ++ show ein)
--pcnf Ptrue = Ptrue
--pcnf Pfalse = Pfalse
--pcnf (Pnot x) = Pand [Por [(Pnot x)]] 
--pcnf (Pvar x) = Pand [Por [(Pvar x)]] 
--pcnf (Por xs) = if (all (pistliteral) xs) then Pand [Por xs]
--                else pcnf  (Pand [Por xs])
                     

--pcnf (Pand xs) = if (all pistliteral xs) 
--                 then Pand (map (\x -> Por [x]) xs)
--                 else if istklauselemenge (Pand xs) 
--                 then Pand xs
--                 else 
--                 if (any pistliteral xs)
--                 then Pand (map littoor xs)
--                 --   Pand Por Pand geschachtelt  
--                  else let  res = pelimflat (Pand  (concat (map distrorand xs)))   --korrektur:???  
--                   --   alter Fehler        else let  res = Pand (concat (map distrorand xs))        
--                        in if (Pand  xs) /= res  
--                            then pcnf1 res
--                     --       then pcnf  res
--                            else res
-- 
--  pcnf1 ein  = error ("pcnf1 " ++ show ein)
littoor (Pnot x) = Por [Pnot x]
littoor (Pvar x) = Por [Pvar x]
littoor x = x
                          
--- distrorand Por (Pand...)    
distrorand (Por xs) = distrorandr   xs 
distrorand _  = error "distrorand: kein Por"
distrorandr  xs =   let xs1 = mkandlist xs
                        xs2 = pandprod xs1
                     in xs2                                              

mkandlist [] = []
mkandlist ((Pand x):xs) = x: mkandlist xs
mkandlist (x:xs) = [x]: mkandlist xs

mkorlist [] = []
mkorlist ((Por x):xs) = x: mkorlist xs
mkorlist (x:xs) = [x]: mkorlist xs

--      
--pandprod:: [[Pexpr a]] -> [Pexpr a]
pandprod xs =  (map Por (pandprodr xs))
pandprodr [e] = map (\x -> [x]) e
pandprodr (x:xs) = 
   let xsr = pandprodr xs 
    in   [xe:xsre | xe <- x, xsre <- xsr] 


cnfTautremov (Pand cls) =  Pand   (cnfTautremovL  cls) 
         --   hier muesste    Pand  (nub (cnfTautremovL  cls) ) stehen, dafuer muss man aber die Klauseln sortieren
cnfTautremov cls =   error ("cnfTautremov keine Klauselmenge " ++ show cls)
cnfTautremovL  [] = []
cnfTautremovL  ((Por cl):clr) = if   cnfIsTaut cl 
                                        then   cnfTautremovL   clr 
                                        else    (Por (nub cl)): (cnfTautremovL   clr) 
                                        
cnfTautremovL cl  =   error ("cnfTautremovL:  keine Klauselmenge" ++ show cl)

cnfIsTaut cl   =  (cl ==  [Ptrue]) || cnfIsTautr cl cl 
--  cnfIsTaut cl   =  cnfIsTautr cl cl    --  vor Maerz 2008
cnfIsTautr [] cl = False
cnfIsTautr ((Pnot (Pvar x)):clr) cl = ((Pvar x) `elem` cl) ||  cnfIsTautr  clr  cl 
cnfIsTautr (_:clr) cl =  cnfIsTautr  clr  cl 

---cnf expr  = cnfTautremov  . pelimflat. pcnf . pelimflat. pelimnot. pelimimpl .   pelimequiv $ expr 
--Neu:  071005
cnf :: (Fresh name, Ord name, Show name) => Pexpr name -> Pexpr name
--   cnf expr  = cnfTautremov  . pelimflat. pcnf . pelimflat. pcnf . pelimflat. pelimTF . pelimnot. pelimimpl .   pelimequiv $ expr 
cnf expr  = cnfTautremov  . pelimflat. pcnf . pelimflat. pcnf . pelimflat. pelimTF . pelimnot. pelimimpl .   pelimequiv   $ expr 
cnffast expr  =  cnfTautremov  . pelimflat. pcnf . pelimflat. pcnf . pelimflat. pelimTF . pelimnot. pelimimpl .   pelimequiv . fastcnfInt $ expr 


  --  pelimTF  2008 eingefuegt 
  
dpcnf (Pand xs) =  
  let res = if xs == [Por [Ptrue]] then   [] 
            else if xs == [Pfalse] || xs == [Por [Pfalse]]  then [[]]
             else map dpcnfor xs 
   in res
dpcnf x = dpcnf (Pand [x])   

dpcnfor (Por xs) = map  dpcnfint xs  
dpcnfor  (Pvar x) = [x]
dpcnfor  (Pnot (Pvar x)) = [-x]
dpcnfor  x  = error $ show x
dpcnfint (Pvar x) = x
dpcnfint (Pnot  (Pvar x)) = -x
dpcnfint x  = error ("dpcnfint " ++ show x)

testdpcnfint = dpcnf (Pand [Por [Pnot (Pvar 1), Pvar 2], Por [Pvar 3,Pnot (Pvar 4)]])
 
test = cnf (Pequiv (Pvar "aa") (Pvar "bb"))

test2 = cnf (Pand [Pand [(Pvar "a1"), (Pvar "a2")],  Pand [(Pvar "b1"), (Pvar "b2")]])  
--test2  ergibt: 
--Pand [Por [Pvar "a1",Por [Pvar "a2",Por [Pvar "b1",Por [Pvar "b2"]]]]] :: Pexpr
-- pandsublst (Pand [Pand [(Pvar "a1"), (Pvar "a2")],  Pand [(Pvar "b1"), (Pvar "b2")]]) 
test3 = pelimflat (Pand [Pand [(Pvar "a1"), (Pvar "a2")],  Pand [(Pvar "b1"), (Pvar "b2")]]) 
test4 = pelimflat (Pand [Pvar "a1",Pvar "a2",Pvar "b1",Pvar "b2"] )  
test5exprlst =   [Pand [Pvar "a",Pvar "b"], Pand [Pvar "c",Pvar "d"]]  
test5expr =  (Por test5exprlst) 
-- pandprod ( mkandlist test5exprlst)   ergibt etwas falsches  
test5 = cnf test5expr


xprod [x]    = map (\y -> [y]) x
xprod (x:xs) = 
   let xsp = xprod xs 
    in [xe:xspp |  xe <- x, xspp <- xsp]


test6 = cnf (Pnot (Pimpl (Pvar "a" ) (Pimpl (Pvar "b" ) (Pvar "a" ))))
test61 =  pelimflat. pelimnot. pelimimpl .   pelimequiv $ (Pnot (Pimpl (Pvar "a" ) (Pimpl (Pvar "b" ) (Pvar "a" )))) 
test62 =   pelimflat. pelimnot. pelimimpl .   pelimequiv $  (Pnot (Pimpl (Pvar "a" ) (Pimpl (Pvar "b" ) (Pvar "a" ))))  

test7 = pcnf test7expr
test7expr =   (Por [Pand [Pvar "a",Pvar "b"], Pand [Pvar "c",Pvar "d"]])

pVarNumber bnds  Ptrue   = (bnds, Ptrue)
pVarNumber bnds  Pfalse  = (bnds, Pfalse)
pVarNumber bnds (Pnot e) = (bnds', Pnot e') where (bnds', e') = pVarNumber bnds e
pVarNumber bnds (Pvar s) = case (lookup s table) of
  Nothing -> ((i+1, (s,i) : table), Pvar i)
  Just n  -> (bnds,                 Pvar n)
  where
    (i, table) = bnds

{-
pVarNumber bnds (Pand es) =
  (bnds', Pand es') where (bnds', es') = mapAccumL pVarNumber bnds es

pVarNumber bnds (Por es)  =
  ... same schema, hence: -}

pVarNumber bnds (Pand es)      = pVarNumberList bnds Pand es
pVarNumber bnds (Por  es)      = pVarNumberList bnds Por  es

{- 
pVarNumber bnds (Pimpl  e1 e2) = pVarNumberList bnds (\[x,y] -> Pimpl  x y) [e1, e2]
pVarNumber bnds (Pequiv e1 e2) = pVarNumberList bnds (\[x,y] -> Pequiv x y) [e1, e2]
  relies on two elements in the list, same as: -}

pVarNumber bnds (Pimpl  e1 e2) = pVarNumberList bnds (foldr1 Pimpl)  [e1, e2]
pVarNumber bnds (Pequiv e1 e2) = pVarNumberList bnds (foldr1 Pequiv) [e1, e2]

pVarNumberList bnds c es =
   (bnds', c es') where (bnds', es') = mapAccumL' pVarNumber bnds es

mapAccumL' _ s []        =  (s, [])
mapAccumL' f s (x:xs)    =  (s'',y:ys)
                           where (s', y ) = f s x
                                 (s'',ys) = seq s' (mapAccumL' f s' xs)

       
       
numProp :: (Eq a, Num b) => Pexpr a -> Pexpr b
numProp  = snd . pVarNumber (1, [])

numPropSubs :: (Eq a, Num b) => Pexpr a -> ([(a,b)],Pexpr b) 
numPropSubs x  =  let  ((_,asso),p) = pVarNumber (1, []) x
                in (asso,p) 

backSubs [] subs = []
backSubs (x:xs) subs = doBackSubs x subs : backSubs xs subs 

doBackSubs x [] = error "doBackSubs"
doBackSubs x ((a,n):arest) = 
    if n == x then a
    else if -n == x 
         then '-':a
         else doBackSubs x  arest    

pBoundVars  e =   nub (pBoundVarsr e)
--pBoundVars  e =   let res = nub (pBoundVarsr e) 
--                  in  error ("pboundvars:  " ++(show e) ++ "  res  " ++  (show res))
pBoundVarsr Ptrue = []
pBoundVarsr Pfalse = []
pBoundVarsr (Pvar x) = [x]
pBoundVarsr (Pand es) =  concat (map pBoundVarsr es) 
pBoundVarsr (Por es) =  concat (map pBoundVarsr es) 
pBoundVarsr (Pimpl e f) = concat (map pBoundVarsr [e,f]) 
pBoundVarsr  (Pequiv e f) = concat (map pBoundVarsr [e,f]) 
pBoundVarsr (Pnot e) =  pBoundVarsr e 

{- Beispiel

Prelude> :l workspaces/second/provide/lehre/WS2008/KI/programme/Simp.hs
Reading file "workspaces/second/provide/lehre/WS2008/KI/programme/Simp.hs":
Reading file "/usr/share/hugs/lib/List.hs":
Reading file "/usr/share/hugs/lib/Maybe.hs":
Reading file "/usr/share/hugs/lib/List.hs":
Reading file "workspaces/second/provide/lehre/WS2008/KI/programme/Prop.hs":
Reading file "workspaces/second/provide/lehre/WS2008/KI/programme/Simp.hs":

Hugs session for:
/usr/share/hugs/lib/Prelude.hs
/usr/share/hugs/lib/Maybe.hs
/usr/share/hugs/lib/List.hs
workspaces/second/provide/lehre/WS2002/KI/programme/Prop.hs
workspaces/second/provide/lehre/WS2002/KI/programme/Simp.hs
Simp> snd $ pVarNumber (1,[]) $ (prop . lexProp 1 0) "A /\\ B /\\ C => A <=> A"
Pimpl (Pand [Pand [Pvar 1,Pvar 2],Pvar 3]) (Pequiv (Pvar 1) (Pvar 1)) :: Pexpr Integer
(1785 reductions, 3236 cells)
Simp> 

-}

testfastcnf =  fastcnfInt    ((parseProp  testequiv9_tx) :: Pexpr [Char])
testequiv9_tx =  ("((A <=> (B <=> (C <=> (D <=> (E <=> (F<=> (G<=> (H <=>I))))))))" 
   ++ "<=>" ++  
  "(B <=> (C <=> (D <=> (E <=> (F <=> (G<=> (H<=> (I <=>A)))))))))")

testfast10 =  fastcnfInt    ((parseProp  testequiv10_tx) :: Pexpr [Char])
testequiv10_tx =  ("(-( (A <=> (B <=> (C <=> (D <=> (E <=> (F<=> (G<=> (H <=>(I <=> J)))))))))"
     ++ "<=>" ++  
   "(B <=> (C <=> (D <=> (E <=> (F <=> (G<=> (H<=> (I <=> (J <=> A))))))))) ))")
